#include "common.h"

struct tms  tmss;

struct pkq_t		pkque[MAXQNum];
int	count;

int inqueue (char * incomingbuff)
{
	struct ipv6_t	ip6temp;
	struct udp_t	*udptemp;
	int				i, destq;

	decapip6(incomingbuff, &ip6temp, MAXPKSIZE);

	//printf("InQue: version%d, filename=%s, streamid %d, len:%d, nexthdr%d\n", ip6temp.version, ip6temp.filename, ip6temp.flowtable, ip6temp.payloadlen, ip6temp.nextheader);
	
	destq=-1;

	for (i=0; i<MAXQNum; i++) //find an queue with same streamid
	{
		if ((ip6temp.flowtable==pkque[i].streamid)&&(pkque[i].numofpkg>0))
		{
			destq=i;
			break;
		}
	}

	if (destq==-1) //try to locate a new queue
	{
		for (i=0; i<MAXQNum; i++)
		{
			if (pkque[i].numofpkg==0)
			{
				destq=i;
				pkque[destq].streamid=ip6temp.flowtable;
				break;
			}
		}
	}

	if (destq==-1) //run out of queues
	{
		printf("Run out of queues! Increase MAXQNum!\n");
		return (-1);
	}

	bcopy(&ip6temp, &pkque[destq].quepkg[pkque[destq].numofpkg], MAXPKSIZE);  //in queue
	pkque[destq].numofpkg++;  //update numofpkg
	if (pkque[destq].numofpkg>MAXBuffNum)  //check overflow
	{
		printf("InQueue: Queue is not long enough, increase MAXBuffNum\n");
		return (-2);
	}


	if (ip6temp.nextheader==UDPH)
		udptemp=(struct udp_t *)ip6temp.payload;
	else if (ip6temp.nextheader==EDIPH)
		udptemp=(struct udp_t *)(ip6temp.payload+sizeof(struct ediph_t)); //only allow one edip header at this time
	else
	{
		printf("InQueue: Program only with UDP and one EDIP payload at this time\n");
		return (-3);
	}

	//printf("InQueue: UDP payload length: %d\n", udptemp->length);
	if (udptemp->length==0)   //end of stream
		pkque[destq].complete=1;

	return (destq);
}



int writeque(int destq)
{
	int i;
	struct ipv6_t	ip6buff;
	struct udp_t	udpbuff;
	int filed;
	char			filename[MAXFNAMELEN];

	bcopy(&(pkque[destq].quepkg[0]), &ip6buff, MAXPKSIZE); //=decapip6
	strcpy(filename, ip6buff.filename);
	
	if ( (filed=creat(filename, 0600))<0) 
	{
		printf("file creat error!\n");
		exit(-1);
	}

	close(filed);

	//printf("file %s created\n", filename);

	if ( (filed=open(filename, O_WRONLY))<0) 
	{
		printf("file open error!\n");
		exit(-1);
	}



	for (i=0; i<pkque[destq].numofpkg;i++)
	{
		bcopy(&(pkque[destq].quepkg[i]), &ip6buff, MAXPKSIZE); //=decapip6 
		//decapedip((char*)ip6buff, shmbuffedit, udpbuff, ip6buff.payloadlen, i);

		if (ip6buff.nextheader==UDPH)
			decapudp(ip6buff.payload, &udpbuff, ip6buff.payloadlen);
		else if (ip6buff.nextheader==EDIPH)
			decapudp(ip6buff.payload+sizeof(struct ediph_t), &udpbuff, ip6buff.payloadlen-sizeof(struct ediph_t));
		else 
		{
			printf("Not recognized heaher\n");
			return (-1);
		}

		write(filed, udpbuff.payload, udpbuff.length);
	}
	close (filed);
	count++;
	printf("file#%d:  %s written to disk, from destq#%d\n", count, filename, destq);

	pkque[destq].complete=0;
	pkque[destq].streamid=-1;
	pkque[destq].numofpkg=0;
}


int main(int argc, char **argv)
{
	int					listenfd, connfd;
	socklen_t			len;
	struct sockaddr_in	servaddr, cliaddr;
	char				buff[MAXLINE];
	char				incomebuff[MAXPKSIZE];

	int					i, destq;


	for (i=0; i<MAXQNum; i++)
	{
		pkque[i].numofpkg=0;
		pkque[i].complete=0;
	}

	if ( (listenfd = socket(AF_INET, SOCK_STREAM, 0))<0)
	{
		printf("Socket creation error! Program exit!\n");
		exit (-1);
	}

	bzero(&servaddr, sizeof(servaddr));
	servaddr.sin_family      = AF_INET;
	servaddr.sin_addr.s_addr = htonl(INADDR_ANY);
	servaddr.sin_port        = htons(EUListenPort);	

	if (bind(listenfd, (struct sockaddr *) &servaddr, sizeof(servaddr))<0)
	{
		printf("Binding error! Program exit!\n");
		exit(-1);
	}

	listen(listenfd, LISTENQ);

	count=0;

	for ( ; ; ) 
	{
		len = sizeof(cliaddr);
		connfd = accept(listenfd, (struct sockaddr *) &cliaddr, &len);
		//printf("connection from %s, port %d\n",
		//	   inet_ntop(AF_INET, &cliaddr.sin_addr, buff, sizeof(buff)),
		//	   ntohs(cliaddr.sin_port));
		readn(connfd, incomebuff, MAXPKSIZE);
		close(connfd);

		if ( (destq=inqueue(incomebuff))<0) //in queue
			exit(-1);  
		if (pkque[destq].complete==1)  //a stream complete, copy to shm
		{
		

			//printf("stream at Q#%d finished. writing to file...\n", destq);
			writeque(destq);  //write stream to file
			//printf("Complete writing file # %d\n", count);		
			//times(&tmss);
			//printf("***utime=%d, stime=%d, total=%d\n", tmss.tms_utime, tmss.tms_stime, tmss.tms_utime+tmss.tms_stime);
			
		}
	
   
	}

	return (0);
}
