#include	"common.h"

int
main(int argc, char **argv)
{
	int					listenfd, connfd, fd;
	socklen_t			len;
	struct sockaddr_in	servaddr, cliaddr;
	char				buff[MAXLINE];
	char				incomebuff[MAXPKSIZE];
	char				content[MAXPAYLOAD];
	time_t				ticks;
	struct ipv6_t		ipv6pack;
	struct udp_t		udppack;
	struct udp_t		udptemp[MAXBuffNum];
	int					i;
	char				*ippayloadpointer;

	char				streamreceived[MAXBuffNum*MAXPKSIZE];
	int					streamlen;

	char				filename[MAXFILENAMELEN];
	int					filenamelen;

	int					numofediphs;



	printf("sizeof int here is %d \n", sizeof(int));

	if ( (listenfd = socket(AF_INET, SOCK_STREAM, 0))<0)
	{
		printf("Socket creation error! Program exit!\n");
		exit (-1);
	}

	bzero(&servaddr, sizeof(servaddr));
	servaddr.sin_family      = AF_INET;
	servaddr.sin_addr.s_addr = htonl(INADDR_ANY);
	servaddr.sin_port        = htons(EUListenPort);	

	if (bind(listenfd, (struct sockaddr *) &servaddr, sizeof(servaddr))<0)
	{
		printf("Binding error! Program exit!\n");
		exit(-1);
	}

	listen(listenfd, LISTENQ);

	for ( ; ; ) {

		//================================
		//begin receiving the filename first

		i=0;
		do
		{
			len = sizeof(cliaddr);
			connfd = accept(listenfd, (struct sockaddr *) &cliaddr, &len);
			printf("connection from %s, port %d\n",
			   inet_ntop(AF_INET, &cliaddr.sin_addr, buff, sizeof(buff)),
			   ntohs(cliaddr.sin_port));
			readn(connfd, incomebuff, MAXPKSIZE);
			close(connfd);

			printf("marker1\n");
			decapip6(incomebuff, &ipv6pack, MAXPKSIZE);
			printf("marker2\n");
			printf("nextheader=%d, ippayloadlen=%d, filename=%s\n",ipv6pack.nextheader, ipv6pack.payloadlen, ((struct udp_t*)ipv6pack.payload)->payload);


			ippayloadpointer=ipv6pack.payload;

			numofediphs=0;
			if (ipv6pack.nextheader==EDIPH) //if there is an edip header
			{
				numofediphs=1;
				ippayloadpointer=ipv6pack.payload+sizeof (struct ediph_t);
				while (((struct ediph_t *)ippayloadpointer)->nextheader==EDIPH) //if more than one edip headers
				{
					ippayloadpointer+=sizeof(struct ediph_t);
					numofediphs++;
				}
			}
			printf("marker3\n");

			decapudp(ippayloadpointer, &udppack, ipv6pack.payloadlen-(sizeof(struct ediph_t))*numofediphs);
			printf("In eu: packet #%d  length=%d\n", i, udppack.length);
			
			bcopy(&udppack, &udptemp[i], udppack.length+8);
			i++;
		} while (udppack.length>0);

		i=0;
		streamlen=0;
		while (udptemp[i].length>0)
		{
			bcopy(udptemp[i].payload, streamreceived+streamlen, udptemp[i].length);
			streamlen+=udptemp[i].length;
			i++;
		}

		if (streamlen<MAXFILENAMELEN)
			filenamelen=streamlen;
		else filenamelen=MAXFILENAMELEN;

		bcopy (streamreceived, filename, filenamelen);
		filename[filenamelen]='\0';

		//================================================
		//begin receiving real content here

		i=0;
		do
		{
			len = sizeof(cliaddr);
			connfd = accept(listenfd, (struct sockaddr *) &cliaddr, &len);
			printf("connection from %s, port %d\n",
			   inet_ntop(AF_INET, &cliaddr.sin_addr, buff, sizeof(buff)),
			   ntohs(cliaddr.sin_port));
			readn(connfd, incomebuff, MAXPKSIZE);
			close(connfd);

			decapip6(incomebuff, &ipv6pack, MAXPKSIZE);
			
			ippayloadpointer=ipv6pack.payload;


			numofediphs=0;
			if (ipv6pack.nextheader==EDIPH) //if there is an edip header
			{
				numofediphs=1;
				ippayloadpointer=ipv6pack.payload+sizeof (struct ediph_t);
				while (((struct ediph_t *)ippayloadpointer)->nextheader==EDIPH) //if more than one edip headers
				{
					ippayloadpointer+=sizeof(struct ediph_t);
					numofediphs++;
				}
			}

			decapudp(ippayloadpointer, &udppack, ipv6pack.payloadlen-(sizeof(struct ediph_t))*numofediphs);
			printf("In eu: packet #%d  length=%d\n", i, udppack.length);
			
			bcopy(&udppack, &udptemp[i], udppack.length+8);
			i++;
		} while (udppack.length>0);

		i=0;
		streamlen=0;
		while (udptemp[i].length>0)
		{
			bcopy(udptemp[i].payload, streamreceived+streamlen, udptemp[i].length);
			streamlen+=udptemp[i].length;
			i++;
		}

		//===============================================
		//write file

		if ( (fd=creat(filename, 0600))<0) 
		{
			printf("file creat error!\n");
			exit(-1);
		}

		close(fd);

		printf("file created\n");

		if ( (fd=open(filename, O_WRONLY))<0) 
		{
			printf("file open error!\n");
			exit(-1);
		}


		write(fd, streamreceived, streamlen);
			
		close(fd);
		printf("finish writing file\n");
	
		//ticks = time(NULL);
        //snprintf(buff, sizeof(buff), "%.24s\r\n", ctime(&ticks));
        //write(connfd, buff, strlen(buff));
	}
	return (0);
}

