#include "common.h"

struct tms tmss, tmss1, tmss2, tmss3, tmssencap, tmssapi;
struct shmbuffedit_t shmbuffedit;


void printfile(char *filename)
{
	int fd;
	char	first20[21];

	first20[20]='\0';

	bcopy (shmbuffedit.editable, first20, 20);

	printf("the first 20 char is %s\n", first20);

	if ( (fd=creat(filename, 0600))<0) 
	{
		printf("file creat error!\n");
		exit(-1);
	}

	close(fd);

	printf("mid file created\n");

	if ( (fd=open(filename, O_WRONLY))<0) 
	{
		printf("file open error!\n");
		exit(-1);
	}

	write(fd, shmbuffedit.editable, shmbuffedit.length);
	printf ("file length: %d \n", shmbuffedit.length);
	close(fd);
	printf("finish writing file\n"); 
}


int getstreamid()
{
	int						key, shmid;
	int						*shm;
	struct shmbuffedit_t	*shmtemp;

	key=SHMKEYbuffedit;
	if ((shmid = shmget(key, 0, 0666)) < 0) 
	{
       printf("share memory access error!\n");
	   exit(1);
    }

    if ((shm = shmat(shmid, NULL, 0)) == (int *) -1) {
        printf("share memory attatch error!\n");
        exit(1);
    }

	shmtemp=(struct shmbuffedit_t *)shm;


	while (shmtemp->oktoedit==0)
		usleep(100); //nothing to edit yet, busy waiting


	bcopy(shm, &shmbuffedit, sizeof(struct shmbuffedit_t));

	shmtemp->oktoedit=0;  //set back for arinfsf to use

	/*printf("How many keyword? %d\n", shmbuffedit.realkwlistlen);
	printf("The keyword is %s\n", shmbuffedit.searchresult[0].keyword);
	printf("How many founds for this keyword in this stream? %d\n", shmbuffedit.searchresult[0].numofindex);
	printf("Where are they? %d%d\n", shmbuffedit.searchresult[0].offset[0], shmbuffedit.searchresult[0].offset[1]);
*/
	//printfile("index5.html");
	return (shmbuffedit.flowtable);
}



int keysearch(int streamid, int startpoint, char *key, int keylen, struct searchresult_t *searchresult)
{
	int offset;
	int no;
	int i;

	
	if (streamid!=shmbuffedit.flowtable)
		return (-1);

	no=-1;
	for (i=0; i<shmbuffedit.realkwlistlen; i++)
	{
		if (bcmp(key, shmbuffedit.searchresult[i].keyword, keylen)==0)
			no=i;
	}
	if (no==-1)
	{
		printf("The keyword u input is not in our service range\n");
		return(-2);
	}
	
	bcopy(&(shmbuffedit.searchresult[no]), searchresult, sizeof(struct searchresult_t));
	return (1);
	
}

char customsearch(int streamid, int startpoint, char *key, int keylen, int offset)
{
	char localkey[]="name=";
	char *charp;

	//bcopy(key, localkey, keylen);
	printf("localkey is %s\n", localkey);

	if (streamid!=shmbuffedit.flowtable)
	return ('\0');

	if (startpoint>=shmbuffedit.length)
	{
		printf("startpoint too high\n");
		return ('\0');
	}

	if ( (charp=strstr(shmbuffedit.editable+startpoint, localkey))==NULL)
	{
		printf("localkey not found\n");
		return ('\0');
	}
	else
	{
		return (*(charp+offset));
	}
}
	

int deletebyte(int startpoint, int len)
{
	char		temp[MAXPAYLOADUDP*MAXBuffNum];
	int			i, j;

	
	//printf("what is the startpoint? %d\n", startpoint);
	if (startpoint>=shmbuffedit.length)
	{
		printf("Over the shmbuffedit length limit! \n");
		return (-1);
	}

	if (startpoint+len>=shmbuffedit.length)
	{
		printf("Over the shmbuffedit length limit! \n");
		return (-1);
	}

	bcopy(shmbuffedit.editable+startpoint+len, temp, shmbuffedit.length-startpoint-len);
	bcopy(temp, shmbuffedit.editable+startpoint, shmbuffedit.length-startpoint-len);
	shmbuffedit.length-=len;

/*	for (i=0; i<shmbuffedit.realkwlistlen; i++)
	{
		for (j=0; j<shmbuffedit.searchresult[i].numofindex; j++)
		{
			if (shmbuffedit.searchresult[i].offset[j]>=startpoint+len)
				shmbuffedit.searchresult[i].offset[j]-=len;
			if ((shmbuffedit.searchresult[i].offset[j]<startpoint+len)&&
				(shmbuffedit.searchresult[i].offset[j]>=startpoint))
				shmbuffedit.searchresult[i].offset[j]=startpoint;
			//else don't need to change
		}
	}

*/			
	return (1);
}

int insertbyte(int startpoint, char *insertion, int len)
{
	char		temp[MAXPAYLOADUDP*MAXBuffNum];
	int			i, j;


	//printf("what is the startpoint? %d\n", startpoint);

	if (startpoint>=shmbuffedit.length)
	{
		printf("Starting point is over the shmbuffedit length limit! \n");
		return (-1);
	}

	if (shmbuffedit.length+len>=MAXPAYLOADUDP*MAXBuffNum)
	{
		printf("Over the shmbuffedit length limit after insertion! \n");
		return (-1);
	}

	bcopy(shmbuffedit.editable+startpoint, temp, shmbuffedit.length-startpoint);
	bcopy(insertion, shmbuffedit.editable+startpoint, len);
	bcopy(temp, shmbuffedit.editable+startpoint+len, shmbuffedit.length-startpoint);
	shmbuffedit.length+=len;

	for (i=0; i<shmbuffedit.realkwlistlen; i++)
	{
		for (j=0; j<shmbuffedit.searchresult[i].numofindex; j++)
		{
			if (shmbuffedit.searchresult[i].offset[j]>=startpoint)
				shmbuffedit.searchresult[i].offset[j]+=len;
			//else don't need to change
		}
	}



	return (1);
}


int sendstream(int streamid)
{
	int						key, shmid;
	int						*shm;
	struct shmbuffarout_t	*shmbuffarout;
	struct	chop_t			choptemp[MAXBuffNum];
	int						choptempsz;
	char					outgoingbuff[MAXPKSIZE];
	struct udp_t			udppk;
	struct	ipv6_t			ipv6pk;
	char					*c;
	int						i;
	int						udppksize;



	key=SHMKEYbuffarout;
	if ((shmid = shmget(key, 0, 0666)) < 0) 
	{
       printf("share memory access error!\n");
	   exit(1);
    }

    if ((shm = shmat(shmid, NULL, 0)) == (int *) -1) {
        printf("share memory attatch error!\n");
        exit(1);
    }

	shmbuffarout=(struct shmbuffarout_t *)shm;


	if (streamid!=shmbuffedit.flowtable)
	{
		printf("no such streamid for edit\n");
		return (-1);
	}




	choptempsz=chop(shmbuffedit.editable, shmbuffedit.length, choptemp, MAXCHOPSIZE);



	for (i=0 ; i<choptempsz; i++) 
	{
		bcopy(choptemp[i].content, outgoingbuff, choptemp[i].len);
		udppksize=wrapudp(outgoingbuff, &udppk, choptemp[i].len, shmbuffedit.sourceport, shmbuffedit.destport);
		//printf("udp payload size: %d\n", udppksize-8);
		
		wrapipv6((char *)&udppk, &ipv6pk, udppksize, shmbuffedit.sourceaddr, shmbuffedit.destinaddr, shmbuffedit.flowtable, UDPH, shmbuffedit.filename);
		//printf("in sendstream: filename=%s, streamid=%d\n", shmbuffedit.filename, shmbuffedit.flowtable);

		//printf("streamid: %d,  ipv6 size: %d\n", ipv6pk.flowtable, ipv6pk.payloadlen);


		if (shmbuffarout->shmrealsize>MAXBuffNum-1)
			printf("In apiedif: shmbuffarout full, wait to clear...\n");
		while (shmbuffarout->shmrealsize>MAXBuffNum-1)
			usleep(100); //wait to clear buffer

		if (shmbuffarout->shmwriting==1)
			printf("shmbuffarout is writing, wait...\n");
		while (shmbuffarout->shmwriting==1)
			usleep(100); //busy waiting;

		shmbuffarout->shmwriting=1;  //lockout

		c=(shmbuffarout->shmbuff)+MAXPKSIZE*(shmbuffarout->shmrealsize);
		bcopy(&ipv6pk, c, MAXPKSIZE);
		(shmbuffarout->shmrealsize)++;
		
		shmbuffarout->shmwriting=0;  //release lock
		
	}

	return (0);

}



int bannerconvert(int startpoint, int endpoint, char *out)  //not a very solid code
{
	char *temp1;
	char *temp2;
	char *charp;
	char areaname[32];
	int areanamelen;
	char urlname[64];
	int urlnamelen;
	char* limit;
	int outlen;

	int abc1len, abc2len, abc3len, abc4len;

	char abc1[]="<a href=\"";
	char abc2[]="\">";
	char abc3[]="</a>";
	char abc4[]="&nbsp;";

	abc1len=strlen(abc1);
	abc2len=strlen(abc2);
	abc3len=strlen(abc3);
	abc4len=strlen(abc4);


	charp=shmbuffedit.editable+startpoint;
	limit=strstr(charp, "</MAP>");
	printf("limit inital= %c\n", *(limit+2));
	outlen=0;

	bcopy("<small>", out, 7);
	outlen+=7;

	while (	(charp=strstr(charp, "<AREA name=\""))<limit)
	{
		if (charp==NULL) break;
		if (charp!=NULL)
		{
			charp+=12; //sizeof (<AREA name=")
			temp1=charp;
			printf("temp1 inital= %c\n", *temp1);
			charp=strstr(charp, "\"");
			//charp+=1; //sizeof (")
			temp2=charp;
			printf("temp2 inital= %c%c\n", *(temp2-2), *(temp2-1));
			if (temp2-temp1<32)
			{
				printf("Inside if\n");
				bcopy(temp1, areaname, temp2-temp1);
				areanamelen=temp2-temp1;
				areaname[areanamelen]='\0';
				printf("areanamelen=%d, areaname=%s\n", areanamelen, areaname);
			}
			else return (-1);
		}
		
		charp=strstr(charp, "href=\"");
		if (charp!=NULL)
		{
			charp+=6; //sizeof(href=")
			temp1=charp;
			printf("temp1 inital= %c\n", *temp1);
			charp=strstr(charp, "\"");
			//charp+=1; //sizeof(");
			temp2=charp;
			printf("temp2 inital= %c%c\n", *(temp2-2), *(temp2-1));
			if (temp2-temp1<64)
			{
				bcopy(temp1, urlname, temp2-temp1);
				urlnamelen=temp2-temp1;
				urlname[urlnamelen]='\0';
				printf("urlnamelen=%d, urlname=%s \n", urlnamelen, urlname);
			}
		}

		bcopy(abc1, out+outlen, abc1len);
		outlen+=abc1len;

		bcopy(urlname, out+outlen, urlnamelen);
		outlen+=urlnamelen;

		bcopy(abc2, out+outlen, abc2len);
		outlen+=abc2len;

		bcopy(areaname, out+outlen, areanamelen);
		outlen+=areanamelen;

		bcopy(abc3, out+outlen, abc3len);
		outlen+=abc3len;

		bcopy(abc4, out+outlen, abc4len);
		outlen+=abc4len;

		bcopy(abc4, out+outlen, abc4len);
		outlen+=abc4len;

		bcopy(abc4, out+outlen, abc4len);
		outlen+=abc4len;


	}

	bcopy("</small>", out+outlen, 8);
	outlen+=8;

	return (outlen);


}





int main()
{
	int streamid;
	int offset;
	int string0len, string1len, string2len, string3len, string4len, string5len, outbuffheadlen, outbufftaillen;
	char outbuff[MAXPKSIZE*MAXBuffNum];
	int outbufflen;
	struct searchresult_t searchresult0, searchresult1, searchresult2, searchresult3, searchresult4, searchresult5;

	int level;
	char c;
	int	templen;

	int i;
	int fd;
	int temp;
	int temp0, temp1;

	int count;

	int result0, result1, result2, result3, result4, result5;

	int configarraysz;
	char configarray[30];
	char	configline[30];

	int convertoutlen;
	char convertoutput[MAXPKSIZE];

	FILE *apiconfigfp;


	char	string0[]="<AD>";
	char	string1[]="</AD>";
	char	string2[]="<MAP";
	char	string3[]="</MAP>";
	char	string4[]="<CONTENT";
	char	string5[]="</CONTENT>";

	//char	stringname[]="name=";

	char    outbuffhead[]="<html><head><title>Adapted page of Yahoo</title></head><body><table border=\"0\" width=\"240\">";
	char	outbufftail[]="</table></body></html>";


	

	tmssencap.tms_utime=0;
	tmssencap.tms_stime=0;
	tmssapi.tms_utime=0;
	tmssapi.tms_stime=0;



	string1len=strlen(string1);
	string0len=strlen(string0);
	string3len=strlen(string3);
	string2len=strlen(string2);
	string5len=strlen(string5);
	string4len=strlen(string4);

	outbuffheadlen=strlen(outbuffhead);
	outbufftaillen=strlen(outbufftail);

	

	count=0;
	for (; ; )
	{
		times(&tmss1);
		//printf("tmss1: total: utime=%d, stime=%d, total=%d\n", tmss1.tms_utime, tmss1.tms_stime, (int)tmss1.tms_utime+(int)tmss1.tms_stime);
		
		streamid=getstreamid();
		
		
		if ( (apiconfigfp=fopen("./apiconfig.edif", "r"))==NULL)
		{
			printf("apiconfig file Open error!\n");
			exit(-1);
		}

		configarraysz=0;
		while ( fgets(configline, 30, apiconfigfp)!=NULL)
		{
			if (isalpha(configline[0]))
			{
				configarray[configarraysz]=configline[0]; //put the initial in config arrary
				configarraysz++;
			}
		}
		fclose(apiconfigfp);
		printf("configarray are: ");
		for (i=0; i<configarraysz; i++)
			printf("%c", configarray[i]);
		printf("\n");


		bzero(&searchresult2, sizeof(searchresult2));
		bzero(&searchresult3, sizeof(searchresult3));
		bzero(&searchresult4, sizeof(searchresult4));
		bzero(&searchresult5, sizeof(searchresult5));

		//result0=keysearch(streamid, 0, string0, string0len, &searchresult0);
		//result1=keysearch(streamid, 0, string1, string1len, &searchresult1);
		result2=keysearch(streamid, 0, string2, string2len, &searchresult2);
		result3=keysearch(streamid, 0, string3, string3len, &searchresult3);
		result4=keysearch(streamid, 0, string4, string4len, &searchresult4);
		result5=keysearch(streamid, 0, string5, string5len, &searchresult5);

		if ((result2<0)||(result3<0)||(result4<0)||(result5<0))
		{
			printf("some keyword not found\n");
		}
		else if ((searchresult2.numofindex!=searchresult3.numofindex)||
				(searchresult4.numofindex!=searchresult5.numofindex))
		{
			printf("some keyword not match\n");
		}
		else			 
		{
			printf("keyword found and matched\n");




			outbufflen=0;
			strcpy(outbuff+outbufflen, outbuffhead);
			outbufflen+=outbuffheadlen;


			for (level=0; level<configarraysz; level++)
			{
				for (i=0; i<searchresult4.numofindex; i++)
				{
					c=customsearch(streamid, searchresult4.offset[i], NULL, 5, 5); //see customsearch for detail
					printf("name initial in searchresult4 is %c \n", c);
					if (c==configarray[level])
					{
						switch(c){
						case 't':
							printf("here\n");
							convertoutlen=bannerconvert(searchresult4.offset[i], searchresult5.offset[i], convertoutput);
							if (convertoutlen>0)
							{
								printf("for layout \"%c\"\n", c);
								
								strcpy(outbuff+outbufflen, "<TR><TD><center><font face=\"Arial\" size=\"5\"><b><u>Yahoo!</u></b></font><center></TD></TR>");
								outbufflen+=strlen("<TR><TD><center><font face=\"Arial\" size=\"5\"><b><u>Yahoo!</u></b></font><center></TD></TR>");
								
								strcpy(outbuff+outbufflen, "<TR><TD><CENTER>");
								outbufflen+=strlen("<TR><TD><CENTER>");
								
								bcopy(convertoutput, outbuff+outbufflen, convertoutlen);
								outbufflen+=convertoutlen;
								
								strcpy(outbuff+outbufflen, "</CENTER></TD></TR>");
								outbufflen+=strlen("</CENTER></TD></TR>");
							}
							break;
						default:
							printf("for layout \"%c\"\n", c);
							strcpy(outbuff+outbufflen, "<TR>");
							outbufflen+=strlen("<TR>");
							templen=searchresult5.offset[i]-searchresult4.offset[i]+string5len;
							bcopy(shmbuffedit.editable+searchresult4.offset[i], outbuff+outbufflen, templen);
							outbufflen+=templen;
							strcpy(outbuff+outbufflen, "</TR>");
							outbufflen+=strlen("</TR>");
							break;
						}
					}
				}
			}

			strcpy(outbuff+outbufflen, outbufftail);
			outbufflen+=outbufftaillen;
			outbuff[outbufflen]='\0';
			printf("outbufflen=%d, outbuff=%s\n\n", outbufflen, outbuff);

			bcopy(outbuff, shmbuffedit.editable, outbufflen+1);
			shmbuffedit.length=outbufflen;
			
		}

	//printfile("index3.html");

		times(&tmss2);
		printf("tmss2: utime=%d, stime=%d, total=%d\n",tmss2.tms_utime, tmss2.tms_stime, tmss2.tms_utime+tmss2.tms_stime);


		sendstream(streamid);

		times(&tmss3);
		printf("tmss3: utime=%d, stime=%d, total=%d\n",tmss3.tms_utime, tmss3.tms_stime, tmss3.tms_utime+tmss3.tms_stime);
		

		tmssapi.tms_utime+=(tmss2.tms_utime-tmss1.tms_utime);
		tmssapi.tms_stime+=(tmss2.tms_stime-tmss1.tms_stime);
		tmssencap.tms_utime+=(tmss3.tms_utime-tmss2.tms_utime);
		tmssencap.tms_stime+=(tmss3.tms_stime-tmss2.tms_stime);
		
		printf("api: utime=%d, stime=%d, total=%d\n", tmssapi.tms_utime, tmssapi.tms_stime, tmssapi.tms_utime+tmssapi.tms_stime);
		printf("encap: utime=%d, stime=%d, total=%d\n", tmssencap.tms_utime, tmssencap.tms_stime, tmssencap.tms_utime+tmssencap.tms_stime);

		count++;

		times(&tmss);
		printf("file#%d: total: utime=%d, stime=%d, total=%d\n\n", count, tmss.tms_utime, tmss.tms_stime, tmss.tms_utime+tmss.tms_stime);
		

	}

	return(0);
}




	
